#define PRECISION 1000
#include "exfloat.h"
#include <iostream>
using namespace std;

int main(int argc, char *argv[])
{
    if(argc < 2) {
        cerr << "usage: " << argv[0] << " N\n";
        return 1;
    }
    exfloat input = argv[1];
    exfloat end = sqrt(input);
    exfloat two = 2;
    
    exfloat m = 3;
    while (m <= end) {

        exfloat q = floor(input / m);
	exfloat r = input - q * m;

        if (r == 0) {
          cout << setiosflags(ios::fixed) << input << " is not a prime number\n";
          cout << m << " is a divisor\n";
          cout << input << '=' << m << '*' << q << endl;
          return 0;
        }
        m = m + two;
    }
    
    cout << setiosflags(ios::fixed) << input << " is a prime number\n";

    return 0;
}
