! -*- f90 -*-
!----------------------------------------------------------------------
! using exflib_array
!----------------------------------------------------------------------

    PROGRAM main

      USE exflib
      USE exflib_array
      IMPLICIT NONE

      TYPE(exfloat) :: a(5), a1, a2, a3
      TYPE(exfloat) :: m(2,3), m1, m2
      INTEGER :: i, j

      a = (/3,-1,-4,5,2/)

      WRITE(*,*) DBLE(a)

      a1 = MAXVAL(a)
      a2 = MAXVAL(a, mask=(a < a1))

      WRITE(*,*) 'a1=', DBLE(a1) , 'a2=', DBLE(a2)

      a3 = MAXVAL(a, a > a1)
      WRITE(*,*) 'a3=', TRIM(exflib_format('e.6', a3))

      a2 = MINVAL(a)
      a3 = MINVAL(a, a < a2)
      WRITE(*,*) 'a3=', TRIM(exflib_format('e.6', a3))

      a3 = SUM(a, a > a1)
      WRITE(*,*) 'a3=', DBLE(a3)
      a3 = PRODUCT(a, a > a1)
      WRITE(*,*) 'a3=', DBLE(a3)

      !--------------------------------------------------

      m = RESHAPE((/2,4, 4,-1, -6,-1/), (/2,3/))

      DO i = 1, SIZE(m,1)
         DO j = 1, SIZE(m,2)
            WRITE(*,'(f8.4,$)') DBLE( m(i,j) )
         END DO
         WRITE(*,*)
      END DO
      WRITE(*,*)

      ! column oriented search
      WRITE(*,*) 'MAXLOC=', MAXLOC( m )

      WRITE(*,*) 'SUM=', DBLE( SUM(m) )
      WRITE(*,*) 'SUM, >0 =', DBLE( SUM(m, mask=(m>0)) )
      WRITE(*,*) 'SUM,DIM=1=', DBLE( SUM(m, DIM=1) )
      WRITE(*,*) 'SUM,DIM=2=', DBLE( SUM(m, DIM=2) )

    END PROGRAM main

!----------------------------------------------------------------------
