! floating-point manipulation
PROGRAM main

  USE exflib

  TYPE(exfloat) :: x, y
  x = 1
  
  WRITE(*,*) 'DIGITS = ', DIGITS(x)
  WRITE(*,*) 'RADIX = ', RADIX(x)
  WRITE(*,*) 'PRECISION = ', PRECISION(x)
  WRITE(*,*) 'EPSILON = ', TRIM(exflib_format('e',EPSILON(x)))
  WRITE(*,*) 'HUGE = ', TRIM(exflib_format('e.16',HUGE(x)))
  WRITE(*,*) 'TINY = ', TRIM(exflib_format('e.16',TINY(x)))
  WRITE(*,*) 'MAXEXPONENT = ', MAXEXPONENT(x)
  WRITE(*,*) 'MINEXPONENT = ', MINEXPONENT(x)
  WRITE(*,*) 'RANGE = ', RANGE(x)

  y = 1
  WRITE(*,*) 'SIGN = ', TRIM(exflib_format('e.16', SIGN(x, y)))
  y = -1
  WRITE(*,*) 'SIGN = ', TRIM(exflib_format('e.16', SIGN(x, y)))

  WRITE(*,*) 'EXPONENT = ', EXPONENT(x)
  WRITE(*,*) 'FRACTION = ', TRIM(exflib_format('e.16',FRACTION(x)))

  y = 1
  WRITE(*,*) 'NEAREST = ', TRIM(exflib_format('e.16', NEAREST(x, y)))
  y = -1
  WRITE(*,*) 'NEAREST = ', TRIM(exflib_format('e.16', NEAREST(x, y)))

  WRITE(*,*) 'SET_EXPONENT = ', TRIM(exflib_format('e.16', SET_EXPONENT(-x, -1)))
  WRITE(*,*) 'SET_EXPONENT = ', TRIM(exflib_format('e.16', SET_EXPONENT(-x, 0)))
  WRITE(*,*) 'SET_EXPONENT = ', TRIM(exflib_format('e.16', SET_EXPONENT(-x, 1)))
  WRITE(*,*) 'SPACING = ', TRIM(exflib_format('e.16', SPACING(x)))
  WRITE(*,*) 'RRSPACING = ', TRIM(exflib_format('e.16', RRSPACING(x)))

END PROGRAM main
