!----------------------------------------------------------------------
! Test program
!----------------------------------------------------------------------

    PROGRAM main

      USE exflib

      TYPE(exfloat) :: a, b, x

      REAL(8) :: a_dbl, b_dbl, x_dbl
      CHARACTER(150) :: str
      INTEGER :: i

      a=10
      b=a**(-10)
      WRITE(*,*) dble(a), dble(b)
      a = 0
      b = a**2
      b_dbl = b
      write(6,*) b_dbl
      stop

      a = 1
      b = 1
      x = a + b

      a = 1
      b = 1
      x = a + b
      WRITE(*,*) x

      b = -1
      b_dbl = b
      WRITE(*,*) 'b = -1 = ', b_dbl
      WRITE(*,*) 'b = -1 = ', exflib_double(b)

      ! c_prec is defined in exflib.f90 module,
      ! but that is private in the module.
      WRITE(*,*) c_prec

      b = "#PI"

      ! suppress a newline, and print only a newline
      str = exflib_format('F.100', b)
      WRITE(*, '(a,$)') TRIM(str)
      WRITE(*, *)

      WRITE(*,*) TRIM(exflib_format('F.100', b))
      WRITE(*,*) TRIM(exflib_format('F.120', b))
      WRITE(*,*) TRIM(exflib_format('H', b))
      
      a = '#PI/2'
      b = '#E*2'

      a_dbl = a
      WRITE(*,*) 'a = pi/2 = ', a_dbl
      b_dbl = b
      WRITE(*,*) 'b = e*2 = ', b_dbl

      x = a + b
      x_dbl = x
      WRITE(*,*) 'a+b = ', x_dbl

      x = a - b
      x_dbl = x
      WRITE(*,*) 'a-b = ', x_dbl

      x = a * b
      x_dbl = x
      WRITE(*,*) 'a*b = ', x_dbl

      x = a * 2
      x_dbl = x
      WRITE(*,*) 'a*2 = ', x_dbl

      x = 2 * a
      x_dbl = x
      WRITE(*,*) '2*a = ', x_dbl

      x = a / b
      x_dbl = x
      WRITE(*,*) 'a/b = ', x_dbl

      x = a / 2
      x_dbl = x
      WRITE(*,*) 'a/2 = ', x_dbl

      x = (a / b) * b
      x_dbl = x
      WRITE(*,*) '(a/b)*b = ', x_dbl

      a = 1
      a_dbl = a
      WRITE(*,*) 'a = ', a_dbl

      b = -1
      b_dbl = b
      WRITE(*,*) 'b = ', b_dbl

      a = "#PI"
      a = +a
      b = -a
      WRITE(*,*) '+PI = ', TRIM(exflib_format('f.60',a))
      WRITE(*,*) '-PI = ', TRIM(exflib_format('f.60',b))

      a = -b
      WRITE(*,*) '-(-PI) = ', TRIM(exflib_format('f.60',a))

      x = abs(a)
      x_dbl = x;
      WRITE(*,*) 'abs(a) = ', x_dbl

      x = abs(b)
      x_dbl = x;
      WRITE(*,*) 'abs(b) = ', x_dbl

      if( a < b ) then
         WRITE (*,*) 'a is less than b'
      else
         WRITE (*,*) 'a is greater than or equal to b'
      endif

      x = sqrt(a)
      b = x*x
      WRITE(*,*) TRIM(exflib_format('f.60', a))
      WRITE(*,*) TRIM(exflib_format('f.60', x))
      WRITE(*,*) TRIM(exflib_format('f.60', b))
      
      a = tan(x)
      WRITE(*,*) TRIM(exflib_format('f.60', x))
      WRITE(*,*) TRIM(exflib_format('f.60', a))

      i = 1
      b = i - a
      WRITE(*,*) TRIM(exflib_format('f.60', b))
    END PROGRAM main

!----------------------------------------------------------------------
