#define PRECISION 1000
#include "exfloat.h"
#include <iostream>
#include <iomanip>
using namespace std;

#include "exfutil.h"
#include "func_sqrt.c"

int main()
{
    exfloat U = 10;
    int N = 10000;
    exfloat EPS = "1e-995";

    exfloat h = U / N;

    for(int i = 0; i < N; i++){
	exfloat x = i*h;
	exfloat y = sqrt(x);
        exfloat y_old = sqrt_old(x);
        
	if(abs(y - y_old) > EPS)
	    cout << x << ' ' << y << endl;
    }

    return 0;
}

// End of file
