// -*- C++ -*-
// $Id: napier.cpp,v 1.1.1.1 2002/04/07 07:18:10 fujiwara Exp $

#define PRECISION 1000
#include <iostream>
#include "exfloat.h"
using namespace std;

int main()
{
  exfloat term, e, old_e;
  long i;

  old_e = 1;
  e = 2;
  term = 1;
  
  for(i = 2; e != old_e; i++){
    term /= i;
    old_e = e;
    e += term;
  }

  cout << setiosflags(ios::scientific) << e << '\n';
  cout << setiosflags(ios::fixed) << setprecision(100) << e << '\n';
  
  e = "#NAPIER";
  cout << e << endl;

  return 0;
}

// Local Variables:
// compile-command: "g++ -Wall -O2 -L.. -o napier napier.cpp -lexf"
// End:
