
    SUBROUTINE exflib_check_array1

      USE exflib
      USE exflib_array
      IMPLICIT NONE

      INTEGER*4 :: i, ix(5), iy(5)
!      INTEGER*8 :: q
      TYPE(exfloat) :: x(5), y(5)
      TYPE(ezfloat) :: z(5), w(5)
      REAL*8 :: d

      ix = (/3,5,-2, -1, 5/)
      WRITE(*,*) 'Array=', ix
      x = ix
      WRITE(*,*) DBLE(x)

      z = ix
      ! z = CMPLX( ix )
      WRITE(*,*) CMPLX(z)

      DO i = 1, SIZE(ix)
!         x(i) = ix(i)
         z(i) = CMPLX(ix(i), ix(i))
      END DO

      WRITE(*,*) CMPLX(z)

      WRITE(*,*) 'SUM of iArray =', SUM(ix)
      WRITE(*,*) 'SUM of xArray =', exflib_double(SUM(x))
      WRITE(*,*) 'SUM of zArray =', TRIM(exflib_format('f.6',SUM(z)))

!      WRITE(*,*) 'SUM MASK of iArray =', SUM(ix, ix.gt.0)
!      WRITE(*,*) 'SUM MASK of xArray =', exflib_double(SUM(x,x.gt.0))

      WRITE(*,*) 'PROD of iArray =', PRODUCT(ix)
      WRITE(*,*) 'PROD of xArray =', exflib_double(PRODUCT(x))
      WRITE(*,*) 'PROD of zArray =', TRIM(exflib_format('f.6', PRODUCT(z)))

      WRITE(*,*) 'DOT_PROD of iArray =', DOT_PRODUCT(ix,ix)
      WRITE(*,*) 'DOT_PROD of xArray =', exflib_double(DOT_PRODUCT(x,x))
      WRITE(*,*) 'DOT_PROD of zArray =', &
           TRIM(exflib_format('f.6',DOT_PRODUCT(z,z)))

!      WRITE(*,*) 'MAXVAL(i)=', MAXVAL(ix)
!      WRITE(*,*) 'MAXVAL(x)=', exflib_double(MAXVAL(x))
!      WRITE(*,*) 'MINVAL(i)=', MINVAL(ix)
!      WRITE(*,*) 'MINVAL(x)=', exflib_double(MINVAL(x))

!      WRITE(*,*) 'MAXLOC(i)=', MAXLOC(ix)
!      WRITE(*,*) 'MAXLOC(x)=', MAXLOC(x)
!      WRITE(*,*) 'MINLOC(i)=', MINLOC(ix)
!      WRITE(*,*) 'MINLOC(x)=', MINLOC(x)

      w = x
      WRITE(*,*) 'assign=', CMPLX( w )

      iy(1:2) = ix(1:2) + ix(3:4)
      y(1:2) = x(1:2) + x(3:4)
      w = z + z
      WRITE(*,*) 'iiArray add=', iy
      WRITE(*,*) 'xxArray add=', DBLE(y)
      WRITE(*,*) 'zzArray add=', CMPLX(w)
      w = x + z
      WRITE(*,*) 'xzArray add=', CMPLX(w)
      w = z + x
      WRITE(*,*) 'zxArray add=', CMPLX(w)
      y = +x
      WRITE(*,*) 'unarray +x=', DBLE(y)
      w = +z
      WRITE(*,*) 'unarray +x=', CMPLX(z)


      iy = iy - ix
      y = y - x
      w = w - z
      WRITE(*,*) 'iiArray sub=', iy
      WRITE(*,*) 'xxArray sub=', DBLE(y)
      WRITE(*,*) 'zzArray sub=', CMPLX(w)
      w = x - z
      WRITE(*,*) 'xzArray sub=', CMPLX(w)
      w = z - x
      WRITE(*,*) 'zxArray sub=', CMPLX(w)
      y = -x
      WRITE(*,*) 'unaray -x =', DBLE(y)
      w = -z
      WRITE(*,*) 'unaray -z =', CMPLX(w)

      iy = iy * ix
      y = y * x
      w = w * z
      WRITE(*,*) 'iiArray mul=', iy
      WRITE(*,*) 'xxArray mul=', DBLE(y)
      WRITE(*,*) 'zzArray mul=', CMPLX(w)
      w = x * z
      WRITE(*,*) 'xzArray mul=', CMPLX(w)
      w = z * x
      WRITE(*,*) 'zxArray mul=', CMPLX(w)

      iy = iy * ix
      y = y * x
      w = w * z
      WRITE(*,*) 'iiArray mul=', iy
      WRITE(*,*) 'xxArray mul=', DBLE(y)
      WRITE(*,*) 'zzArray mul=', CMPLX(w)
      w = x * z
      WRITE(*,*) 'xzArray mul=', CMPLX(w)
      w = z * x
      WRITE(*,*) 'zxArray mul=', CMPLX(w)

      i = 7
      iy = i * ix
      WRITE(*,*) 'i*iArray mul=', iy
!      q = -2
!      iy = q * ix
!      WRITE(*,*) 'q*iArray mul=', iy

      y = i * x
      WRITE(*,*) 'i*xArray mul=', DBLE(y)
!      y = q * x
!      WRITE(*,*) 'q*xArray mul=', DBLE(y)
      y = x * i
      WRITE(*,*) 'xArray*i mul=', DBLE(y)
!      y = x * q
!      WRITE(*,*) 'xArray*q mul=', DBLE(y)

      w = i * z
      WRITE(*,*) 'i*xArray mul=', CMPLX(w)
!      w = q * z
!      WRITE(*,*) 'q*xArray mul=', CMPLX(w)
      w = z * i
      WRITE(*,*) 'xArray*i mul=', CMPLX(w)
!      w = z * q
!      WRITE(*,*) 'xArray*q mul=', CMPLX(w)
      
      w = i * x
      WRITE(*,*) 'i*xArray mul=', CMPLX(w)
!      w = q * x
!      WRITE(*,*) 'q*xArray mul=', CMPLX(w)
      w = x * i
      WRITE(*,*) 'xArray*i mul=', CMPLX(w)
!      w = x * q
!      WRITE(*,*) 'xArray*q mul=', CMPLX(w)

      iy = iy / ix
      y = y / x
      w = w / z
      WRITE(*,*) 'iiArray div=', iy
      WRITE(*,*) 'xxArray div=', DBLE(y)
      WRITE(*,*) 'zzArray div=', CMPLX(w)
      w = x / z
      WRITE(*,*) 'xzArray div=', CMPLX(w)
      w = z / x
      WRITE(*,*) 'zxArray div=', CMPLX(w)

      y = x / i
!      WRITE(*,*) 'xArray/i div=', DBLE( y(2) )
      WRITE(*,*) 'xArray/i div=', DBLE(y)
!      y = x / q
!      WRITE(*,*) 'xArray/q div=', DBLE(y)

    END SUBROUTINE exflib_check_array1

!**********************************************************************

    SUBROUTINE exflib_check_array2
      USE exflib
      USE exflib_array
      IMPLICIT NONE

    END SUBROUTINE exflib_check_array2

!**********************************************************************

    PROGRAM main

      CALL exflib_check_array1
      !CALL exflib_check_array2

    END PROGRAM main

!**********************************************************************
