!----------------------------------------------------------------------
! complex type test
!----------------------------------------------------------------------

    PROGRAM main

      USE exflib

      TYPE(exfloat) :: a, b, x, y
      TYPE(ezfloat) :: z, w, zz
      INTEGER*8 :: q1, q2
      INTEGER*8 :: i1, i2
      COMPLEX*8 :: sz
      COMPLEX*16 :: dz
      REAL*4 :: s
      REAL*8 :: d      

      x = 10
      y = 12
      q1 = 21
      q2 = 22
      i1 = 31
      i2 = 32
      sz = cmplx(-1,-2)
      dz = dcmplx(0.0001d0, 0.00030d0)
      s = 0.11111
      d = 0.22222d0

      WRITE(*,*) 'assignment'

      z = '#PI'
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = x
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = q1
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = i1
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx('0.1', '#PI*2')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx('0.2', x)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = cmplx(y, '0.3')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx('0.4', q2)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = cmplx(q1, '0.5')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = cmplx('0.6', i1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = cmplx(i2, '0.7')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx('0.2', x)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = cmplx(x, y)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(x, q1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(q2, y)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(x, i1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(i2, y)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(q1, q2)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(q2, i1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(i2, q1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = cmplx(i1,i2)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      WRITE(*,*) dcmplx(z), TRIM(exflib_format('f.30', z))

      WRITE(*,*) 'assignment, polar form'

      z = polar('0.1', '#PI*2')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar('0.2', x)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = polar(y, '0.3')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar('0.4', q2)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = polar(q1, '0.5')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = polar('0.6', i1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = polar(i2, '0.7')
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar('0.2', x)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))
      
      z = polar(x, y)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(x, q1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(q2, y)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(x, i1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(i2, y)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(q1, q2)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(q2, i1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(i2, q1)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      z = polar(i1,i2)
      WRITE(*,*) cmplx(z), TRIM(exflib_format('f.30', z))

      WRITE(*,*) 'auxiality'
      WRITE(*,*) 'real', DBLE(real(z))
!      WRITE(*,*) 'imag', DBLE(imag(z))
      WRITE(*,*) 'aimag', DBLE(aimag(z))
      WRITE(*,*) 'conjg', cmplx(conjg(z))
      WRITE(*,*) 'arg', DBLE(arg(z))

      WRITE(*,*) 'arithmetic, add'
      w = cmplx('0.01', '0.02')

      zz = z + w
      WRITE(*,*) cmplx(zz)
      
      zz = z + x
      WRITE(*,*) cmplx(zz)

      zz = y + z
      WRITE(*,*) cmplx(zz)

      zz = z + q1
      WRITE(*,*) cmplx(zz)

      zz = q2 + z
      WRITE(*,*) cmplx(zz)

      zz = z + i1
      WRITE(*,*) cmplx(zz)

      zz = i2 + z
      WRITE(*,*) cmplx(zz)

      zz = +z
      WRITE(*,*) cmplx(zz)

      WRITE(*,*) 'arithmetic, sub'

      zz = z - w
      WRITE(*,*) cmplx(zz)
      
      zz = z - x
      WRITE(*,*) cmplx(zz)

      zz = y - z
      WRITE(*,*) cmplx(zz)

      zz = z - q1
      WRITE(*,*) cmplx(zz)

      zz = q2 - z
      WRITE(*,*) cmplx(zz)

      zz = z - i1
      WRITE(*,*) cmplx(zz)

      zz = i2 - z
      WRITE(*,*) cmplx(zz)

      zz = -z
      WRITE(*,*) cmplx(zz)

      WRITE(*,*) 'arithmetic, mul'

      zz = z * w
      WRITE(*,*) cmplx(zz)
      
      zz = z * x
      WRITE(*,*) cmplx(zz)

      zz = y * z
      WRITE(*,*) cmplx(zz)

      zz = z * q1
      WRITE(*,*) cmplx(zz)

      zz = q2 * z
      WRITE(*,*) cmplx(zz)

      zz = z * i1
      WRITE(*,*) cmplx(zz)

      zz = i2 * z
      WRITE(*,*) cmplx(zz)

      WRITE(*,*) 'arithmetic, div'

      zz = z / w
      WRITE(*,*) cmplx(zz)
      
      zz = z / x
      WRITE(*,*) cmplx(zz)

      zz = y / z
      WRITE(*,*) cmplx(zz)

      zz = z / q1
      WRITE(*,*) cmplx(zz)

      zz = q2 / z
      WRITE(*,*) cmplx(zz)

      zz = z / i1
      WRITE(*,*) cmplx(zz)

      zz = i2 / z
      WRITE(*,*) cmplx(zz)

      WRITE(*,*) 'comparison, eq'

      IF ( z == w ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF
      
      IF ( z == dz ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z == sz ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( dz == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( sz == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z == x ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF
         
      IF ( x == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z == q1 ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z == i1 ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z == d ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z == s ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( q1 == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( i1 == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( d == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( s == z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      WRITE(*,*) 'comparison, neq'

      IF ( z /= w ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF
      
      IF ( z /= dz ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z /= sz ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( dz /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( sz /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z /= x ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF
         
      IF ( x /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z /= q1 ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z /= i1 ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z /= d ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( z /= s ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( q1 /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( i1 /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( d /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      IF ( s /= z ) THEN
         WRITE(*,*) 'equal'
      ELSE
         WRITE(*,*) 'differ'
      END IF

      WRITE(*,*) 'built-in functions'
      
      WRITE(*,*) 'abs', DBLE(abs(cmplx(1,2)))
      WRITE(*,*) 'abs', DBLE(abs(cmplx(5,4)))
      WRITE(*,*) 'abs', DBLE(abs(cmplx(-6,-6)))
      WRITE(*,*) 'abs', DBLE(abs(cmplx(0,0)))

      WRITE(*,*) 'arg', DBLE(arg(cmplx(1,1)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(1,0)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(1,-1)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(0,1)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(0,0)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(0,-1)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(-1,1)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(-1,0)))
      WRITE(*,*) 'arg', DBLE(arg(cmplx(-1,-1)))

      z = cmplx(1,1)
      WRITE(*,*) 'sin', cmplx(sin(z))
      WRITE(*,*) 'cos', cmplx(cos(z))
      WRITE(*,*) 'tan', cmplx(tan(z))

      WRITE(*,*) 'exp', cmplx(exp(z))
      WRITE(*,*) 'pow', cmplx(z**2)
      WRITE(*,*) 'pow', cmplx(z**3)
      WRITE(*,*) 'pow', cmplx(z**4)
      WRITE(*,*) 'pow', cmplx(z**5)
      WRITE(*,*) 'pow', cmplx(pow(z,w))
      WRITE(*,*) 'pow', cmplx(pow(z,y))
      WRITE(*,*) 'pow', cmplx(pow(x,w))
      WRITE(*,*) 'pow', cmplx(pow(z,q1))
      WRITE(*,*) 'pow', cmplx(pow(q2,w))
      WRITE(*,*) 'pow', cmplx(pow(z,i1))
      WRITE(*,*) 'pow', cmplx(pow(i2,w))

      WRITE(*,*) 'log', cmplx(log(z))
      WRITE(*,*) 'log10', cmplx(log10(z))
      
      WRITE(*,*) 'sinh', cmplx(sinh(z))
      WRITE(*,*) 'cosh', cmplx(cosh(z))
      WRITE(*,*) 'tanh', cmplx(tanh(z))

    END PROGRAM main

!----------------------------------------------------------------------
