! Print version
PROGRAM main

  USE exflib

!  WRITE(*,*) 'Required precision = ', exflib_get_req_precision()
!  WRITE(*,*) 'Current precision = ', exflib_get_precision()
!  WRITE(*,*) 'An exfloat is', exflib_get_exfloat_byte(), 'bytes.'
!  WRITE(*,*) 'Current libexfloat.a is ', TRIM(exflib_get_version())

  TYPE(exfloat) :: x

  WRITE(*,*) 'Required precision (decimal digits):', exflib_exfloat_precision10
  WRITE(*,*) 'Current precision (decimal digits) :', DIGITS(x)
  WRITE(*,*) 'Current precision (bits, including the hidden one):', PRECISION(x)

  WRITE(*,*) 'Machine Epsilon (gap between 1 and the next value) : ', &
       TRIM(exflib_format('e.6', EPSILON(x)))

  WRITE(*,*)

  WRITE(*,*) 'Current precision :', exflib_exfloat_precision, 'digits.'
  WRITE(*,*) 'An exfloat number consists of', exflib_exfloat_size, 'INTEGER*8 elements.'
  WRITE(*,'(a,i0,a)') ' Entity is num(0:', exflib_exfloat_size-1, ')'
  WRITE(*,*) 'The size of exfloat is', exflib_exfloat_byte, 'bytes.'
  WRITE(*,*) 'Current libexfloat.a is ', TRIM(exflib_version())

END PROGRAM main
